// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cpm_ts_msgs
const rosidl_type_hash_t *
etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x13, 0x48, 0xd1, 0xb8, 0x8d, 0x0f, 0xc3, 0x62,
      0x26, 0x46, 0x2c, 0xf4, 0x71, 0xfc, 0x39, 0xae,
      0x61, 0x69, 0xad, 0x3e, 0x6a, 0x69, 0x85, 0x95,
      0x6e, 0xeb, 0xe6, 0xce, 0xb9, 0x34, 0x3d, 0x54,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__TYPE_NAME[] = "etsi_its_cpm_ts_msgs/msg/AccelerationConfidence";

// Define type names, field names, and default values
static char etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__FIELDS[] = {
  {
    {etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__TYPE_NAME, 47, 47},
      {etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn\n"
  "#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cpm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the acceleration confidence value which represents the estimated absolute accuracy of an acceleration value with a default confidence level of 95 %. \n"
  "#  * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `n` (`n > 0` and `n < 101`) if the confidence value is equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,\n"
  "#  * - `101` if the confidence value is out of range i.e. greater than 10 m/s^2,\n"
  "#  * - `102` if the confidence value is unavailable.\n"
  "#  *\n"
  "#  * The value 0 shall not be used.\n"
  "#  *\n"
  "#  * @note: The fact that an acceleration value is received with confidence value set to `unavailable(102)` can be caused by several reasons, such as:\n"
  "#  * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,\n"
  "#  * - the sensor cannot calculate the accuracy due to lack of variables, or\n"
  "#  * - there has been a vehicle bus (e.g. CAN bus) error.\n"
  "#  * In all 3 cases above, the acceleration value may be valid and used by the application.\n"
  "#  * \n"
  "#  * @note: If an acceleration value is received and its confidence value is set to `outOfRange(101)`, it means that the value is not valid and therefore cannot be trusted. Such value is not useful for the application.\n"
  "#  *\n"
  "#  * @unit 0,1 m/s^2\n"
  "#  * @category: Kinematic information\n"
  "#  * @revision: Description revised in V2.1.1\n"
  "#  */\n"
  "# AccelerationConfidence ::= INTEGER {\n"
  "#     outOfRange                 (101), \n"
  "#     unavailable                (102)\n"
  "# } (0..102)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 102\n"
  "uint8 OUT_OF_RANGE = 101\n"
  "uint8 UNAVAILABLE = 102\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__TYPE_NAME, 47, 47},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3834, 3834},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cpm_ts_msgs__msg__AccelerationConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
