// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cpm_ts_msgs:msg/CoordinateConfidence.idl
// generated code does not contain a copyright notice

#include "etsi_its_cpm_ts_msgs/msg/detail/coordinate_confidence__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cpm_ts_msgs
const rosidl_type_hash_t *
etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xe0, 0x94, 0x69, 0x3a, 0xd7, 0xd0, 0x74, 0x96,
      0x94, 0x03, 0x5d, 0x9b, 0xd9, 0xbc, 0x06, 0xc5,
      0x80, 0x49, 0xd7, 0xb8, 0xc7, 0xa7, 0xde, 0x58,
      0x46, 0x28, 0xa4, 0xfa, 0x34, 0xfe, 0x07, 0x70,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__TYPE_NAME[] = "etsi_its_cpm_ts_msgs/msg/CoordinateConfidence";

// Define type names, field names, and default values
static char etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__FIELDS[] = {
  {
    {etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__TYPE_NAME, 45, 45},
      {etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn\n"
  "#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cpm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE indicates the coordinate confidence value which represents the estimated absolute accuracy of a position coordinate with a default confidence level of 95 %.\n"
  "#  * If required, the confidence level can be defined by the corresponding standards applying this DE.\n"
  "#  *\n"
  "#  * The value shall be set to: \n"
  "#  * - `n` (`n > 0` and `n < 4095`) if the confidence value is is equal to or less than n x 0,01 metre, and greater than (n-1) x 0,01 metre,\n"
  "#  * - `4095` if the confidence value is greater than 40,94 metres,\n"
  "#  * - `4096` if the confidence value is not available.\n"
  "#  *\n"
  "#  * @unit 0,01 m\n"
  "#  * @category: Basic information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# CoordinateConfidence ::= INTEGER {\n"
  "#     outOfRange            (4095),\n"
  "#     unavailable           (4096) \n"
  "# } (1..4096)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 1\n"
  "uint16 MAX = 4096\n"
  "uint16 OUT_OF_RANGE = 4095\n"
  "uint16 UNAVAILABLE = 4096\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3049, 3049},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cpm_ts_msgs__msg__CoordinateConfidence__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
