// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_cpm_ts_msgs:msg/Latitude.idl
// generated code does not contain a copyright notice

#include "etsi_its_cpm_ts_msgs/msg/detail/latitude__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_cpm_ts_msgs
const rosidl_type_hash_t *
etsi_its_cpm_ts_msgs__msg__Latitude__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xdb, 0xa2, 0x63, 0xea, 0x01, 0x2c, 0xe6, 0x7d,
      0xd5, 0xda, 0xc1, 0x55, 0x70, 0x8f, 0x9a, 0xd5,
      0x99, 0x5d, 0x24, 0xb5, 0x4b, 0xf0, 0xcc, 0x45,
      0x05, 0xe0, 0x9d, 0xe3, 0x1a, 0x18, 0xc7, 0x97,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_cpm_ts_msgs__msg__Latitude__TYPE_NAME[] = "etsi_its_cpm_ts_msgs/msg/Latitude";

// Define type names, field names, and default values
static char etsi_its_cpm_ts_msgs__msg__Latitude__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_cpm_ts_msgs__msg__Latitude__FIELDS[] = {
  {
    {etsi_its_cpm_ts_msgs__msg__Latitude__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_cpm_ts_msgs__msg__Latitude__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_cpm_ts_msgs__msg__Latitude__TYPE_NAME, 33, 33},
      {etsi_its_cpm_ts_msgs__msg__Latitude__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn\n"
  "#   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn\n"
  "#   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   cpm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or\n"
  "#  * in south hemisphere.\n"
  "#  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,\n"
  "#  * - `0` is used for the latitude of the equator,\n"
  "#  * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,\n"
  "#  * - `900 000 001` when the information is unavailable.\n"
  "#  *\n"
  "#  * @unit: 10^-7 degree\n"
  "#  * @category: GeoReference information\n"
  "#  * @revision: Editorial update in V2.1.1\n"
  "#  */\n"
  "# Latitude ::= INTEGER {\n"
  "#     unavailable(900000001)\n"
  "# } (-900000000..900000001)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int32 value\n"
  "int32 MIN = -900000000\n"
  "int32 MAX = 900000001\n"
  "int32 UNAVAILABLE = 900000001\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_cpm_ts_msgs__msg__Latitude__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_cpm_ts_msgs__msg__Latitude__TYPE_NAME, 33, 33},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3087, 3087},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_cpm_ts_msgs__msg__Latitude__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_cpm_ts_msgs__msg__Latitude__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
